/*
 * TableDrawer.java
 * Tomokazu ARITA
 * arita@obirin.ac.jp
 * Created on 2003/11/18, 2:18
 * up 2005/12/04
 */

package org.hichart.h3code.gui;

import java.awt.Graphics2D;
//import java.awt.Dimension;
import java.awt.Color;
import java.awt.Paint;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

import org.hichart.h3code.AbstractCell;
import org.hichart.h3code.Cell;
import org.hichart.h3code.Table;
import org.hichart.h3code.content.ContentToolkit;

public class TableDrawer {
    
    private Paint bgColor = (Paint)Color.white; //wi̐F
    private Paint borderColor = (Paint)Color.black; //Z̐̐F
    private Paint targetColor = (Paint)Color.cyan;//^[Qbg̃J[
    
    
    //RXgN^
    public TableDrawer(){}
    
    /* e[u̕` */
    public void draw(Graphics2D g2, Table table, TargetManager target_manager){
        if(table == null || g2 ==null){ return; }//e[uȂȂΏI
        
        /* wiFŔwi` */
        if(bgColor != null){
            g2.setPaint(bgColor); //wi̐FZbg
            g2.fillRect(0, 0, table.getWidth(), table.getHeight()); //wi`
        }
        
        /* eZ̕` */
        ArrayList cells = table.getCellSet();//e[ȗSZo.
        
        HashSet targets = target_manager.getTargets();//^[QbgZo
        if(targets.size() >=0){//^[QbgȂ
            ArrayList temp_cells = (ArrayList)cells.clone();//SZ̃N[
            temp_cells.removeAll(targets);//^[QbgȊÕZo
            HashSet non_targets = new HashSet(temp_cells);//^[QbgZȊÕZW
            drawNonTargetedCells(g2, non_targets);//^[QbgȊÕZ`
            drawTargetedCells(g2, targets);//^[Qbg̕`
        }else{
            drawTargetedCells(g2, cells);//^[QbgȊÕZ` <--BUG? or ɗȂH
        }
        
        
        
        
    }
    
    //^[Qbgł͂ȂZ̕`
    public void drawNonTargetedCells(Graphics2D g2, java.util.Collection c){
        Iterator it = c.iterator();
        while(it.hasNext()){
            Object obj = it.next();
            if(obj instanceof org.hichart.h3code.Cell){
            	org.hichart.h3code.Cell cell = (org.hichart.h3code.Cell)obj;
                
                /* {[_[̐FZbg */
                g2.setPaint(borderColor);
                
                /* Z̕` */
                g2.drawRect(cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.NORTH), cell.getWall(AbstractCell.EAST)-cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.SOUTH)-cell.getWall(AbstractCell.NORTH));
                
                /* Rec̕`(ǉ) */
                drawContent(g2, cell);
            }
        }
    }
    
    //^[QbgZ̕`
    public void drawTargetedCells(Graphics2D g2, java.util.Collection c){
        Iterator it = c.iterator();
        while(it.hasNext()){
            Object obj = it.next();
            if(obj instanceof org.hichart.h3code.Cell){
            	org.hichart.h3code.Cell cell = (org.hichart.h3code.Cell)obj;
                
                /* wi̐FZbg & `*/
                g2.setPaint(targetColor);
                g2.fillRect(cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.NORTH), cell.getWall(AbstractCell.EAST)-cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.SOUTH)-cell.getWall(AbstractCell.NORTH));
                
                /* {[_[̐FZbg & `*/
                g2.setPaint(borderColor);
                g2.drawRect(cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.NORTH), cell.getWall(AbstractCell.EAST)-cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.SOUTH)-cell.getWall(AbstractCell.NORTH));

                /* Rec̕`(ǉ) */
                drawContent(g2, cell);
            }
        }
    }
    
    
    /**
     * Rec̕`(ǉ)
     * @param g2
     * @param cell
     */
    private void drawContent(Graphics2D g2, Cell cell){
    	//Step1: c[Lbg̍쐬
    	ContentToolkit toolkit = new ContentToolkit(cell);
    	
    	//Step2: yCg̕ۑ
    	Paint paint = g2.getPaint(); //݂̃yCgۑ(Ōɖ߂)
    	
    	//Step3: Rec̕`
    	toolkit.draw(g2);
    	
    	//STEP4: yCgɖ߂
    	g2.setPaint(paint); //yCgɖ߂
    }
}
