/*
 * TableEventAdapter.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/11/17, 0:05
 * Update on 2005/05/30
 */

package org.hichart.h3code.gui;

import java.awt.event.MouseListener;
import java.awt.Component;

import org.hichart.h3code.Table;
import org.hichart.h3code.Cell;


public class TableEventAdapter implements MouseListener,HasTarget{
    
    private Table table = null; //e[u
    private TargetManager target_manager = null;//^[QbgǗ
    private Component component = null;//GUIi
    
    //RXgN^
    public TableEventAdapter(Component component){
        this.component = component;
    }
    
    //Ve[ũCX^Xꂽꍇ
    //K̃\bhŐݒ肷D
    public void setTable(Table table){
        this.table = table;
    }
    
    //NbN
    public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
        if(table == null){ return; }//e[uƂI
        int x = mouseEvent.getX();
        int y = mouseEvent.getY();
        System.out.println("X:"+x+" Y:"+y);
        TableManager table_manager = new TableManager();
        table_manager.setTable(table);
        Cell cell = table_manager.searchCell(x, y);
        if(cell==null){ return; } //bug fix 050530
        if(target_manager.isTarget(cell)){target_manager.removeTarget(cell);}
        else{target_manager.addTarget(cell);}
        component.repaint();//ĕ`
        
        //debug
        if(cell != null){
            System.out.println("A Clicked Cell ="+cell.getID());
            System.out.println("The number of Targets is "+target_manager.getTargets().size());
        }//debug
    }
    
    //R|[lgɓ
    public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
    }
    
    //R|[lgo
    public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
    }
    
    //{^
    public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
    }
    
    //{^
    public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
    }
    
    
    //HasManager\bh
    public TargetManager getTargetManager() {
        return target_manager;
    }
    
    //HasManager\bh
    public void setTargetManager(TargetManager manager) {
        this.target_manager = manager;
    }
    
}
