/*
 * H3CFileFilter.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/08/16, 9:39
 */

package org.hichart.h3code.tool;

//import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;


/**
 * FileFilter class for H3-Code ver. 2.0
 * .htc, .hcc
 * 
 * @author Tomokazu ARITA (arita@obirin.ac.jp)
 * @version 0.1.0 2003/08/16
 * 
 */
public class H3CFileFilter extends javax.swing.filechooser.FileFilter{
    
    private static final String description = "H3-Code Files";
    private ArrayList ext = new ArrayList();
    
    /** Creates a new instance of H3CFileFilter */
    public H3CFileFilter() {
        ext.add(".htc");
        ext.add("hcc");
    }
    
    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
     */
    public boolean accept(java.io.File file) {
        if(file.isDirectory()){
            return true;
        }else if(file.isFile()){
            Iterator it = ext.iterator();
            while(it.hasNext()){
                if(file.getName().endsWith((String)it.next())){
                    return true;
                }
            }
        }
        
        return false;
    }
    
    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#getDescription()
     */
    public String getDescription() {
        return description;
    }
    
}
